%global meadalpha %{nil}
%global meadrel %{nil}
%global version_major 1
%global version_minor 2
%global version_micro 46
%global commitid 039e27580a9cf5f4489280c590dfe61be2230972
%global serial 22
# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%{?scl:%scl_package mod_jk}
%{!?scl:%global pkg_name %{name}}

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%define jws %{nil}

%bcond_with tools

%define with_zips 1
%bcond_with zips

%{!?aprconf: %{expand: %%define aprconf %{_bindir}/apr-config}}
%{!?apxs: %{expand: %%define apxs %{_sbindir}/apxs}}
%if "%{?rhel}" == "6"
%{!?libtool: %{expand: %%define libtool %{_libdir}/apr-jws3-1/build/libtool}}
%else
%{!?libtool: %{expand: %%define libtool %{_libdir}/apr-1/build/libtool}}
%endif
%define aprincludes %(%{aprconf} --includes 2>/dev/null)

Name:      %{?scl_prefix}mod_jk%{jws}
Epoch:     0
Version:   1.2.46
Release:   %{serial}.redhat_1%{?dist}
Summary:   Tomcat mod_jk connector for Apache

Group:     Internet/WWW/Servers
License:   ASL 2.0
URL:       http://tomcat.apache.org
Source0:   tomcat-connectors-%{commitid}.tar.gz
Source1:   %{pkg_name}.conf.sample
Source2:   uriworkermap.properties.sample
Source3:   workers.properties.sample

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires: %{?scl_prefix}httpd%{jws}-devel
BuildRequires: %{?scl_prefix}apr%{jws}-devel
BuildRequires: %{?scl_prefix}apr-util%{jws}-devel
%if "%{?rhel}" >= "7"
# 64 bit only natives on RHEL 7
ExcludeArch:   i386 i686
%endif
BuildRequires: perl
BuildRequires: ant
%if "%{?rhel}" == "6"
BuildRequires: ant-trax
BuildRequires: java7-devel >= 1.6.0
%else
BuildRequires: java-devel >= 1.6.0
%endif
BuildRequires: jpackage-utils >= 0:1.5.38
BuildRequires: libtool
BuildRequires: xalan-j2 >= 2.7.0
BuildRequires: zip

%description
Mod_jk is a replacement to the elderly mod_jserv. It is a completely new
Tomcat-Apache plug-in that handles the communication between Tomcat and Apache.

%package ap24
Summary: Tomcat %{pkg_name} connector for Apache 2.4.x
Group: Internet/WWW/Servers
Provides: %{pkg_name} = %{epoch}:%{version}-%{release}
Obsoletes: tomcat-mod
Obsoletes: %{pkg_name}-ap20 < %{epoch}:%{version}
Obsoletes: %{pkg_name}-ap22 < %{epoch}:%{version}
Obsoletes: mod_jk-tools < %{epoch}:%{version}-%{release}
Requires: %{?scl_prefix}httpd%{jws} >= 2.4.6

%description ap24
Tomcat %{pkg_name} connector for Apache 2.4.x.

%package manual
Summary: Tomcat %{pkg_name} connector manual
Group: Internet/WWW/Servers

%description manual
Tomcat %{pkg_name} connector manual.

%if %with tools
%package tools
Group: Internet/Log Analysis
Summary: Analysis and report tools for %{pkg_name}

%description tools
Miscellaneous %{pkg_name} analysis and report tools.
%endif

%if %with zips
%package src-zip
Summary:     Container for the sources of the Tomcat %{pkg_name} connector.
Group:       Development

%description src-zip
Container for the sources of the Tomcat %{pkg_name} connector.
%endif

%prep
%setup -q -n tomcat-connectors-%{commitid}

%{__sed} -i -e 's|^(APXSCPPFLAGS=.*)$|$1 %{aprincludes}|' \
    native/common/Makefile.in

%build
%if %with zips
zip -q -r ../mod_jk-%{version}-src.zip *
%endif

# Adding the "-z,now" option in LDFLAGS in order to gain
# full RELRO support
%if "%{?rhel}" == "7"
LDFLAGS="$LDFLAGS -Wl,-z,now"
%else
LDFLAGS="$LDFLAGS -Wl,-z,relro,-z,now"
%endif
export LDFLAGS

%{?scl:scl enable %scl - << \EOF}
set -e
pushd native
     rm -f ./configure
    [ -x ./configure ] || sh ./buildconf.sh
    %configure \
        --with-apxs="%{_sbindir}/apxs"
    export LIBTOOL="`%{_sbindir}/apxs -q LIBTOOL 2>/dev/null`"
    # Handle old apxs (without -q LIBTOOL), eg Red Hat 8.0 and 9.
        if test -z "$LIBTOOL"; then
            LIBTOOL="%{libtool}"
        fi
    make %{?_smp_mflags} \
    LIBTOOL="$LIBTOOL" \
    EXTRA_CFLAGS="$RPM_OPT_FLAGS" \
    EXTRA_CPPFLAGS="%{aprincludes}"

popd
pushd xdocs
    CLASSPATH="$(build-classpath xalan-j2-serializer)" %ant
popd
%{?scl:EOF}

%install
%{!?aprconf: %{expand: %%define aprconf %{_bindir}/apr-config}}
%{!?apxs: %{expand: %%define apxs %{_sbindir}/apxs}}
%if "%{?rhel}" == "6"
%{!?libtool: %{expand: %%define libtool %{_libdir}/apr-jws3-1/build/libtool}}
%else
%{!?libtool: %{expand: %%define libtool %{_libdir}/apr-1/build/libtool}}
%endif
%define aplibdir %(%{apxs} -q LIBEXECDIR 2>/dev/null)
%define apconfdir %(%{apxs} -q SYSCONFDIR 2>/dev/null)
%define aplogdir logs
%define aprincludes %(%{aprconf} --includes 2>/dev/null)
%define tc5dir %{_datadir}/tomcat5
%{__rm} -rf $RPM_BUILD_ROOT
install -d -m 755 $RPM_BUILD_ROOT%{_sysconfdir}/httpd%{jws}/conf.d/
install -p -m 0644 %{SOURCE1} %{SOURCE2} %{SOURCE3} $RPM_BUILD_ROOT%{_sysconfdir}/httpd%{jws}/conf.d/
%{__mkdir} -p _ap20
%{__sed} -i -e 's|/usr/local/bin\b|%{_bindir}|' tools/reports/*.pl
command="s|/usr/local/bin\b|%{_bindir}|"
%{__sed} -i -e $command tools/reports/*.pl
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}/%{aplibdir}
%{__install} -p -m 0755 native/apache-2.0/%{pkg_name}.so \
        ${RPM_BUILD_ROOT}/%{aplibdir}/%{pkg_name}.so
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}/%{_bindir}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}/%{_var}/run/%{name}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}/%{_var}/cache/%{name}
# for tools
%if %with tools
%{__install} -p -m 0755 tools/reports/*.pl ${RPM_BUILD_ROOT}/%{_bindir}
%endif

%if %with zips
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_javadir}/jbossas-fordev
%{__install} ../mod_jk-%{version}-src.zip  ${RPM_BUILD_ROOT}%{_javadir}/jbossas-fordev/mod_jk-%{version}-src.zip
%endif

%clean
%{__rm} -rf $RPM_BUILD_ROOT

%files ap24
%{!?apxs: %{expand: %%define apxs %{_sbindir}/apxs}}
%define aplibdir %(%{apxs} -q LIBEXECDIR 2>/dev/null)
%defattr(-,root,root,-)
%doc native/LICENSE native/NOTICE
%doc native/README.txt native/TODO.txt
%{aplibdir}/*
%config(noreplace) %{_sysconfdir}/httpd%{jws}/conf.d/*
%dir %{_var}/run/%{name}
%dir %{_var}/cache/%{name}

%files manual
%defattr(0644,root,root,0755)
%doc build/docs/*

%if %with tools
%files tools
%defattr(-,root,root,-)
%doc tools/reports/README.txt
%{_bindir}/*
%endif

%if %with zips
%files src-zip
%defattr(0644,root,root,0755)
%{_javadir}/jbossas-fordev/mod_jk-%{version}-src.zip
%endif

%changelog
* Fri Oct 11 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 1.2.46-22
-  Rebuilding JBCS httpd 2.4.37-ER5

* Thu Oct 10 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 1.2.46-21
- JBCS httpd 2.4.37-ER5

* Wed Sep 25 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 1.2.46-20
- Building JCBS 2.4.37.ER4

* Fri Sep 20 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 1.2.46-19
- JBCS httpd 2.4.37.ER3

* Thu Aug 29 2019 Hui Wang <huwang@redhat.com> - 1.2.46-17
- Enable src-zip for rhel7

* Tue Aug 06 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 1.2.46-14
- JBCS 2.4.37.ER2

* Wed Jul 24 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 1.2.46-10
- JBCS 2.4.37.ER1

* Fri Jul 19 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 1.2.46-9
- JBCS 2.4.37.ER1

* Wed Jun 19 2019 Hui Wang <huwang@redhat.com> - 1.2.46-6
- Build with new httpd 2.4.37

* Thu Nov 01 2018 Sokratis Zappis <szappis@redhat.com> - 1.2.46-1
- Upgrade to 1.2.46

* Mon Apr 09 2018 Hui Wang <huwang@redhat.com> - 1.2.43-1
- Upgrade to 1.2.43

* Mon Mar 05 2018 Georgios Zaronikas Karagiannis <gzaronik@redhat.com> - 1.2.42-4
- Rebuild with httpd 2.4.29

* Mon Mar 05 2018 Georgios Zaronikas Karagiannis <gzaronik@redhat.com> - 1.2.42-3
- Rebuild with httpd 2.4.29

* Mon Mar 05 2018 Georgios Zaronikas Karagiannis <gzaronik@redhat.com> - 1.2.42-2
- Building with httpd 2.4.29

* Mon Feb 05 2018 Hui Wang <huwang@redhat.com> - 1.2.42-1
- Upgrade to 1.2.42

* Thu Dec 01 2016 Georgios Zaronikas Karagiannis <gzaronik@redhat.com> - 1.2.41-14
- Rebuild for CR1

* Tue Aug 30 2016 Georgios Zaronikas Karagiannis <gzaronik@redhat.com> - 1.2.41-13
- Added relro protection

* Thu Aug 18 2016 Patrick Sutherland <csutherl@redhat.com> - 1.2.41-12
- 

* Mon Jul 25 2016 Patrick Sutherland <csutherl@redhat.com> - 1.2.41-11
- Implementing source-repos feature to use new lookaside repo.
- Resolves: JBCS-119 update mod_jk to 1.2.41

* Thu Jul 21 2016 Jean-Frederic Clere <jclere@redhat.com> - 0:1.2.41-3.redhat_1
- Resolves: rhbz#1357852 RHEL6 i386: mod_jk module is missing symbol, httpd won't start

* Tue Dec 22 2015 Fernando Nasser <fnasser@redhat.com> - 0:1.2.40-9
- Build in the jbcs-httpd24 collection

* Wed May 27 2015 Jean-Frederic Clere <jclere@redhat.com> - 0:1.2.40-8.redhat_1
- JWS-24 Add missing patches.

* Tue Mar 03 2015  Weinan Li <weli@redhat.com> - 0:1.2.40-7.redhat_1
- JWS-14

* Mon Dec 15 2014  Permaine Cheung <pcheung@redhat.com> - 0:1.2.40-6.redhat_1
- Rebuild

* Wed Oct 15 2014  Permaine Cheung <pcheung@redhat.com> - 0:1.2.40-4.redhat_1
- Build against httpd24 on RHEL 6, 7

* Wed Sep 24 2014  Permaine Cheung <pcheung@redhat.com> - 0:1.2.40-3.redhat_1
- JWS 3.0 build
